﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;

namespace SaveLoadSerializationSample.Web
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class DatabaseInteraction
    {
        PivotGridTestsEntities proxy;

        [OperationContract]
        public bool TestConnection()
        {
            if (proxy == null)
                proxy = new PivotGridTestsEntities();

            if (proxy.DatabaseExists())
                return true;
           
            return false;
        }

        [OperationContract]
        public bool UploadView(DateTime stamp, byte[] viewToSave)
        {
            if (proxy == null)
                proxy = new PivotGridTestsEntities();

            if (proxy.DatabaseExists())
            {
                proxy.AddToSerializationSamples(new SerializationSample() { Timestamp = stamp, SavedView = viewToSave });
                proxy.SaveChanges();
                return true;
            }
            return false;
        }

        [OperationContract]
        public byte[] DownloadView(DateTime stamp)
        {
            if (proxy == null)
                proxy = new PivotGridTestsEntities();

            if (proxy.DatabaseExists())
            {
                foreach (SerializationSample currentSample in proxy.SerializationSamples)
                {
                    if (currentSample.Timestamp == stamp)
                    {
                        return currentSample.SavedView;
                    }
                }
            }
            return null;
        }

        [OperationContract]
        public List<string> GetListOfViews()
        {
            List<string> result = new List<string>();
            if (proxy == null)
                proxy = new PivotGridTestsEntities();

            if (proxy.DatabaseExists())
            {
                foreach (SerializationSample currentSample in proxy.SerializationSamples)
                {
                    result.Add(currentSample.Timestamp.ToString());
                }
                return result;
            }
            return null;
        }
    }
}
